#ifndef REGION_H
#define REGION_H

typedef struct region_t
{
	mbloom_t	*crh;
	struct cache_t	*cbv;
	unsigned long	rsize;
	unsigned long	bsize;
	unsigned long 	bshift;
        counter_t       probes;
        counter_t       updates;
	counter_t	outcome[2][2][2];	// real/crh/cbv
        char            *name;
} region_t;

region_t * region_create (char *args, struct stat_sdb_t *sdb);

int region_array_create (region_t *array[], char *args, struct stat_sdb_t *sdb);

void region_alloc (region_t *rp, md_addr_t addr);

void region_dealloc (region_t *rp, md_addr_t addr);

int region_probe (region_t *rp, md_addr_t addr, int real_hit);

#endif

